Index: trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.Designer.cs	(revision 3292)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.Designer.cs	(revision 3292)
@@ -0,0 +1,63 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core.Views {
+  partial class Clipboard {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.SuspendLayout();
+      // 
+      // Clipboard
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Caption = "Clipboard";
+      this.Name = "Clipboard";
+      this.Size = new System.Drawing.Size(316, 296);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+  }
+}
Index: trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.cs	(revision 3292)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.cs	(revision 3292)
@@ -0,0 +1,44 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Core.Views {
+  [View("Clipboard")]
+  public partial class Clipboard : HeuristicLab.MainForm.WindowsForms.View {
+    public Clipboard() {
+      InitializeComponent();
+    }
+
+    protected override void OnInitialized(EventArgs e) {
+      base.OnInitialized(e);
+    }
+    protected override void OnClosing(FormClosingEventArgs e) {
+      base.OnClosing(e);
+      if (e.CloseReason == CloseReason.UserClosing) {
+        e.Cancel = true;
+        this.Hide();
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 3291)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 3292)
@@ -87,4 +87,10 @@
   <ItemGroup>
     <None Include="HeuristicLabCoreViewsPlugin.cs.frame" />
+    <Compile Include="Clipboard.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Clipboard.Designer.cs">
+      <DependentUpon>Clipboard.cs</DependentUpon>
+    </Compile>
     <Compile Include="LogView.cs">
       <SubType>UserControl</SubType>
Index: trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 3291)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 3292)
@@ -87,4 +87,5 @@
     <None Include="HeuristicLabOptimizerPlugin.cs.frame" />
     <Compile Include="FileManager.cs" />
+    <Compile Include="MenuItems\ClipboardMenuItem.cs" />
     <Compile Include="MenuItems\StartPageMenuItem.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/ClipboardMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/ClipboardMenuItem.cs	(revision 3292)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/ClipboardMenuItem.cs	(revision 3292)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Optimizer.MenuItems {
+  internal class ClipboardMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    private ToolStripMenuItem menuItem;
+
+    public override string Name {
+      get { return "&Clipboard"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&View" }; }
+    }
+    public override int Position {
+      get { return 2200; }
+    }
+
+    protected override void OnToolStripItemSet(EventArgs e) {
+      MainFormManager.MainForm.ViewShown += new EventHandler<ViewShownEventArgs>(MainForm_ViewShown);
+      MainFormManager.MainForm.ViewHidden += new EventHandler<ViewEventArgs>(MainForm_ViewHidden);
+
+      menuItem = ToolStripItem as ToolStripMenuItem;
+      if (menuItem != null) {
+        menuItem.CheckOnClick = true;
+        menuItem.Checked = Properties.Settings.Default.ShowClipboard;
+      }
+    }
+
+    private void MainForm_ViewShown(object sender, ViewShownEventArgs e) {
+      if ((e.View is HeuristicLab.Core.Views.Clipboard) && (menuItem != null)) {
+        menuItem.Checked = true;
+        Properties.Settings.Default.ShowClipboard = true;
+        Properties.Settings.Default.Save();
+      }
+    }
+    private void MainForm_ViewHidden(object sender, ViewEventArgs e) {
+      if ((e.View is HeuristicLab.Core.Views.Clipboard) && (menuItem != null)) {
+        menuItem.Checked = false;
+        Properties.Settings.Default.ShowClipboard = false;
+        Properties.Settings.Default.Save();
+      }
+    }
+
+    public override void Execute() {
+      IView clipboard = ((OptimizerMainForm)MainFormManager.MainForm).Clipboard;
+      if (clipboard.IsShown) {
+        clipboard.Hide();
+      } else {
+        clipboard.Show();
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OperatorsMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OperatorsMenuItem.cs	(revision 3291)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OperatorsMenuItem.cs	(revision 3292)
@@ -38,5 +38,5 @@
     }
     public override int Position {
-      get { return 2200; }
+      get { return 2300; }
     }
 
Index: trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs	(revision 3291)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs	(revision 3292)
@@ -30,4 +30,9 @@
 namespace HeuristicLab.Optimizer {
   internal partial class OptimizerMainForm : DockingMainForm {
+    private HeuristicLab.Core.Views.Clipboard clipboard;
+    public HeuristicLab.Core.Views.Clipboard Clipboard {
+      get { return clipboard; }
+    }
+
     public OptimizerMainForm()
       : base() {
@@ -47,4 +52,10 @@
       if (version != null) Title += " " + version.Version;
       ViewClosed += new EventHandler<ViewEventArgs>(FileManager.ViewClosed);
+
+      clipboard = new HeuristicLab.Core.Views.Clipboard();
+      clipboard.Dock = DockStyle.Left;
+      if (Properties.Settings.Default.ShowClipboard) {
+        clipboard.Show();
+      }
       if (Properties.Settings.Default.ShowOperatorsSidebar) {
         OperatorsSidebar operatorsSidebar = new OperatorsSidebar();
Index: trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs	(revision 3291)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs	(revision 3292)
@@ -47,4 +47,16 @@
             }
         }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("True")]
+        public bool ShowClipboard {
+            get {
+                return ((bool)(this["ShowClipboard"]));
+            }
+            set {
+                this["ShowClipboard"] = value;
+            }
+        }
     }
 }
Index: trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings	(revision 3291)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings	(revision 3292)
@@ -9,4 +9,7 @@
       <Value Profile="(Default)">False</Value>
     </Setting>
+    <Setting Name="ShowClipboard" Type="System.Boolean" Scope="User">
+      <Value Profile="(Default)">True</Value>
+    </Setting>
   </Settings>
 </SettingsFile>
Index: trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 3291)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 3292)
@@ -57,5 +57,4 @@
       samplesListView.Enabled = false;
       showStartPageCheckBox.Checked = Properties.Settings.Default.ShowStartPage;
-      Cursor = Cursors.AppStarting;
 
       ThreadPool.QueueUserWorkItem(new WaitCallback(LoadSamples));
@@ -113,5 +112,4 @@
         }
         loadingPanel.Visible = false;
-        Cursor = Cursors.Default;
       }
     }
Index: trunk/sources/HeuristicLab.Optimizer/3.3/app.config
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/app.config	(revision 3291)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/app.config	(revision 3292)
@@ -14,4 +14,7 @@
                 <value>False</value>
             </setting>
+            <setting name="ShowClipboard" serializeAs="String">
+                <value>True</value>
+            </setting>
         </HeuristicLab.Optimizer.Properties.Settings>
     </userSettings>